
/**Copyright (c) 2009, Ioannis (John) Chtzikonstantinou, All rights reserved.
 ***http://prototy.blogspot.com
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 	- Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 	- Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 */
Point2 p1,p2;

void mousePressed() {
  if (!visMode) {
  if (drawMode==0) {
    tx = mouseX;
    ty = mouseY;
    tX=(tx*FLUID_WIDTH/width);
    tY=(ty*FLUID_WIDTH/width);
  }
  }
}
void mouseReleased() {
  if (!visMode) {
  if (abs(tx - mouseX)<3 && abs(ty - mouseY)<3 && drawMode==0) {
    drawMode=1;
  } 
  else if (drawMode==1) {
    p1=new Point2(tX,tY);
    p2=new Point2(mX,mY);
    lineSegments.add(new lineSegment(p1,p2));
    updatelinePoints();
    drawMode=0;
  } 
  else if (drawMode==2) {
    Point2 p3=new Point2(mX,mY);
    thrustSegments.add(new thrustSegment(p1,p2,p3));
    updateThrustPoints();
    drawMode=0;
  }
  else {
    p1=new Point2(tX,tY);
    p2=new Point2(mX,mY);
    drawMode=2;
  }
  }
}
void keyPressed() {
  if (keyCode==' ') {
    tunnelFlow=!tunnelFlow;
  }
  else if (keyCode=='3') {
    drawObj=!drawObj;
  }
  else if (keyCode=='R') {
    fluidSolver.reset();
    lineSegments=new Vector();
    linePoints=new Vector();
    thrustSegments=new Vector();
    thrustPoints=new Vector();
  } else if (keyCode=='1' && visMode) {
    visMode=false;
    state3D=cam.getState();
    cam.setState(state2D,0);
    cam.setMouseControlled(false);
    noCursor();
  } else if (keyCode=='2' && !visMode) {
    visMode=true;
    state2D=cam.getState();
    cam.setState(state3D,0);
    cam.setMouseControlled(true);
    cursor();
  }
  else if (keyCode=='X') {
    export("TN7_out.dxf");
  }
}


