
/**Copyright (c) 2009, Ioannis (John) Chtzikonstantinou, All rights reserved.
 ***http://prototy.blogspot.com
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 	- Redistributions of source code must retain the above copyright 
 * notice, this list of conditions and the following disclaimer.
 * 	- Redistributions in binary form must reproduce the above copyright 
 * notice, this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT 
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE.
 */

class thrustSegment {

  Point2 p1,p2,p3;

  Point2 Pth;

  final float W=1.81;
  final float r=width/FLUID_WIDTH;
  final float w=W*2;
  final float staticMult=.1;

  thrustSegment(Point2 p1in, Point2 p2in, Point2 p3in) {
    p1=p1in;
    p2=p2in;
    p3=p3in;
    Pth=p3.minus(pTL(p1,p2,p3)).mult(staticMult);
  }
  void draw() {
    stroke(130);
    strokeWeight(10);
    line(p1.x*r,p1.y*r,p2.x*r,p2.y*r);
  }
}

public final class thrustPoint2 {

  int index;
  Point2 Pth;

  thrustPoint2(int indexin,Point2 Pthin) {
    index=indexin;
    Pth=Pthin;
  }
  void update() {
    fluidSolver.u[index]+=Pth.x;
    fluidSolver.v[index]+=Pth.y;
  }
}


